package com.clx.performance.listener;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.clx.performance.constant.RabbitKeyConstants;
import com.clx.performance.data.OrderChildData;
import com.msl.common.utils.DtsMapConvertUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.rabbit.annotation.*;
import org.springframework.stereotype.Component;

@Slf4j
@Component
@RabbitListener(bindings = @QueueBinding(
        value = @Queue(value = RabbitKeyConstants.CLX_PERFORMANCE_ORDER_CHILD_QUEUE),
        exchange = @Exchange(name = RabbitKeyConstants.DTS_EXCHANGE),
        key = RabbitKeyConstants.CLX_PERFORMANCE_ORDER_CHILD_KEY
), containerFactory="smartContainerFactory")
public class OrderChildDtsListener  {


    @RabbitHandler
    public void dealMessage(byte[] message) {
        try {
            String msg = new String(message);
            log.info("DTS消息同步开始, database:order_service, msg:{}", msg);

            JSONObject object = JSON.parseObject(msg);

            JSONObject beforeMap = object.getJSONObject("beforeMap");
            JSONObject afterMap = object.getJSONObject("afterMap");
            OrderChildData before = DtsMapConvertUtil.convert(beforeMap, new OrderChildData());
            OrderChildData entity = DtsMapConvertUtil.convert(afterMap, new OrderChildData());


        } catch (Exception e) {
            log.info("DTS消息同步失败, database:order_service, error:{}", e.getMessage());
        }
    }

}
